
#include <stdio.h>
#include "pvm3.h"

#include "mandel.h"

void main() {
  int tids [NNODES] ;
  int array [ARRAYSIZE] ;
  int block [HEADERLEN + BLOCKSIZEMAX] ;
  int i ;
  FILE* f ;
  int nodesActive = NNODES ;
  int counter ;

  pvm_mytid() ;

  /*  Create the node processes.  */

  pvm_spawn("mandel.worker", NULL, PvmTaskDefault, "", NNODES, tids);

  /*  Initalise the work counter.  */

  counter = 0 ;

  while(nodesActive > 0) {
    int node_id, dummy ;
    int blockBase, blockSize ;

    /*  Receive request for new task (and old result data) from some node.  */

    pvm_precv(-1, 0, block, HEADERLEN + BLOCKSIZEMAX, PVM_INT,
              &node_id, &dummy, &dummy) ;

    /*  Send a new task to the node.  */

    pvm_psend(node_id, 1, &counter, 1, PVM_INT) ;

    if(counter >= ARRAYSIZE) nodesActive-- ;  /* Just terminated one node */

    counter += BLOCKSIZEMAX ;

    /*  Copy old result data to `array'.  */
 
    blockBase = block [0] ;
    blockSize = block [1] ;
    for(i = 0 ; i < blockSize ; i++)
      array [blockBase + i] = block [HEADERLEN + i] ;
  }

  /*  Write values in `array' to a `.pgm' file.  */
 
  f = fopen("mandel.pgm", "w") ;

  fprintf(f, "P2\n%3d  %3d\n%3d\n", N, N, RESOLUTION) ;

  for(i = 0 ; i < ARRAYSIZE ; i++) {
    fprintf(f, "%d ", array [i]) ;
    if(i % 20 == 0) fprintf(f, "\n") ;
  }

  fclose(f) ;

  pvm_exit() ;
}

